com.amazonaws.services.lambda

## Class AbstractAWSLambda

- java.lang.Object
- - com.amazonaws.services.lambda.AbstractAWSLambda

All Implemented Interfaces:
  AWSLambda

Direct Known Subclasses:
  AbstractAWSLambdaAsync

    public class AbstractAWSLambda
    extends Object
    implements AWSLambda

Abstract implementation of `AWSLambda`. Convenient method forms pass through to the corresponding overload that takes a request object, which throws an `UnsupportedOperationException`.

### Field Summary

### Fields inherited from interface com.amazonaws.services.lambda.AWSLambda

`ENDPOINT_PREFIX`

### Constructor Summary

Constructors
`protected` `AbstractAWSLambda()`

### Method Summary

All Methods Instance Methods Concrete Methods Deprecated Methods
`AddPermissionResult` `addPermission(AddPermissionRequest request)` Adds a permission to the resource policy associated with the specified AWS Lambda function.
`CreateAliasResult` `createAlias(CreateAliasRequest request)` Creates an alias that points to the specified Lambda function version.
`CreateEventSourceMappingResult` `createEventSourceMapping(CreateEventSourceMappingRequest request)` Identifies a stream as an event source for a Lambda function.
`CreateFunctionResult` `createFunction(CreateFunctionRequest request)` Creates a new Lambda function.
`DeleteAliasResult` `deleteAlias(DeleteAliasRequest request)` Deletes the specified Lambda function alias.
`DeleteEventSourceMappingResult` `deleteEventSourceMapping(DeleteEventSourceMappingRequest request)` Removes an event source mapping.
`DeleteFunctionResult` `deleteFunction(DeleteFunctionRequest request)` Deletes the specified Lambda function code and configuration.
`GetAccountSettingsResult` `getAccountSettings(GetAccountSettingsRequest request)` Returns a customer's account settings.
`GetAliasResult` `getAlias(GetAliasRequest request)` Returns the specified alias information such as the alias ARN, description, and function version it is pointing to.
`ResponseMetadata` `getCachedResponseMetadata(AmazonWebServiceRequest request)` Returns additional metadata for a previously executed successful request, typically used for debugging issues where a service isn't acting as expected.
`GetEventSourceMappingResult` `getEventSourceMapping(GetEventSourceMappingRequest request)` Returns configuration information for the specified event source mapping (see CreateEventSourceMapping).
`GetFunctionResult` `getFunction(GetFunctionRequest request)` Returns the configuration information of the Lambda function and a presigned URL link to the .zip file you uploaded with CreateFunction so you can download the .zip file.
`GetFunctionConfigurationResult` `getFunctionConfiguration(GetFunctionConfigurationRequest request)` Returns the configuration information of the Lambda function.
`GetPolicyResult` `getPolicy(GetPolicyRequest request)` Returns the resource policy associated with the specified Lambda function.
`InvokeResult` `invoke(InvokeRequest request)` Invokes a specific Lambda function.
`InvokeAsyncResult` `invokeAsync(InvokeAsyncRequest request)` Deprecated.
`ListAliasesResult` `listAliases(ListAliasesRequest request)` Returns list of aliases created for a Lambda function.
`ListEventSourceMappingsResult` `listEventSourceMappings()` Simplified method form for invoking the ListEventSourceMappings operation.
`ListEventSourceMappingsResult` `listEventSourceMappings(ListEventSourceMappingsRequest request)` Returns a list of event source mappings you created using the `CreateEventSourceMapping` (see CreateEventSourceMapping).
`ListFunctionsResult` `listFunctions()` Simplified method form for invoking the ListFunctions operation.
`ListFunctionsResult` `listFunctions(ListFunctionsRequest request)` Returns a list of your Lambda functions.
`ListVersionsByFunctionResult` `listVersionsByFunction(ListVersionsByFunctionRequest request)` List all versions of a function.
`PublishVersionResult` `publishVersion(PublishVersionRequest request)` Publishes a version of your function from the current snapshot of $LATEST.
`RemovePermissionResult` `removePermission(RemovePermissionRequest request)` You can remove individual permissions from an resource policy associated with a Lambda function by providing a statement ID that you provided when you added the permission.
`void` `setEndpoint(String endpoint)` Overrides the default endpoint for this client ("lambda.us-east-1.amazonaws.com").
`void` `setRegion(Region region)` An alternative to `AWSLambda.setEndpoint(String)`, sets the regional endpoint for this client's service calls.
`void` `shutdown()` Shuts down this client object, releasing any resources that might be held open.
`UpdateAliasResult` `updateAlias(UpdateAliasRequest request)` Using this API you can update the function version to which the alias points and the alias description.
`UpdateEventSourceMappingResult` `updateEventSourceMapping(UpdateEventSourceMappingRequest request)` You can update an event source mapping.
`UpdateFunctionCodeResult` `updateFunctionCode(UpdateFunctionCodeRequest request)` Updates the code for the specified Lambda function.
`UpdateFunctionConfigurationResult` `updateFunctionConfiguration(UpdateFunctionConfigurationRequest request)` Updates the configuration parameters for the specified Lambda function by using the values provided in the request.

### Methods inherited from class java.lang.Object

`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

### Constructor Detail

#### AbstractAWSLambda

    protected AbstractAWSLambda()

### Method Detail

#### setEndpoint

    public void setEndpoint(String endpoint)

Description copied from interface: `AWSLambda`
Overrides the default endpoint for this client ("lambda.us-east-1.amazonaws.com"). Callers can use this method to control which AWS region they want to work with.

Callers can pass in just the endpoint (ex: "lambda.us-east-1.amazonaws.com") or a full URL, including the protocol (ex: "lambda.us-east-1.amazonaws.com"). If the protocol is not specified here, the default protocol from this client's `ClientConfiguration` will be used, which by default is HTTPS.

For more information on using AWS regions with the AWS SDK for Java, and a complete list of all available endpoints for all AWS services, see: http://developer.amazonwebservices.com/connect/entry.jspa?externalID=3912

This method is not threadsafe. An endpoint should be configured when the client is created and before any service requests are made. Changing it afterwards creates inevitable race conditions for any service requests in transit or retrying.

Specified by:
  `setEndpoint` in interface `AWSLambda`
Parameters:
  `endpoint` - The endpoint (ex: "lambda.us-east-1.amazonaws.com") or a full URL, including the protocol (ex: "lambda.us-east-1.amazonaws.com") of the region specific AWS endpoint this client will communicate with.

#### setRegion

    public void setRegion(Region region)

Description copied from interface: `AWSLambda`
An alternative to `AWSLambda.setEndpoint(String)`, sets the regional endpoint for this client's service calls. Callers can use this method to control which AWS region they want to work with.

By default, all service endpoints in all regions use the https protocol. To use http instead, specify it in the `ClientConfiguration` supplied at construction.

This method is not threadsafe. A region should be configured when the client is created and before any service requests are made. Changing it afterwards creates inevitable race conditions for any service requests in transit or retrying.

Specified by:
  `setRegion` in interface `AWSLambda`
Parameters:
  `region` - The region this client will communicate with. See `Region.getRegion(com.amazonaws.regions.Regions)` for accessing a given region. Must not be null and must be a region where the service is available.
See Also:
  `Region.getRegion(com.amazonaws.regions.Regions)`, `Region.createClient(Class, com.amazonaws.auth.AWSCredentialsProvider, ClientConfiguration)`, `Region.isServiceSupported(String)`

#### addPermission

    public AddPermissionResult addPermission(AddPermissionRequest request)

Description copied from interface: `AWSLambda`

Adds a permission to the resource policy associated with the specified AWS Lambda function. You use resource policies to grant permissions to event sources that use push model. In a push model, event sources (such as Amazon S3 and custom applications) invoke your Lambda function. Each permission you add to the resource policy allows an event source, permission to invoke the Lambda function.

For information about the push model, see AWS Lambda: How it Works.

If you are using versioning, the permissions you add are specific to the Lambda function version or alias you specify in the `AddPermission` request via the `Qualifier` parameter. For more information about versioning, see AWS Lambda Function Versioning and Aliases.

This operation requires permission for the `lambda:AddPermission` action.

Specified by:
  `addPermission` in interface `AWSLambda`
Returns:
  Result of the AddPermission operation returned by the service.

#### createAlias

    public CreateAliasResult createAlias(CreateAliasRequest request)

Description copied from interface: `AWSLambda`

Creates an alias that points to the specified Lambda function version. For more information, see Introduction to AWS Lambda Aliases.

Alias names are unique for a given function. This requires permission for the lambda:CreateAlias action.

Specified by:
  `createAlias` in interface `AWSLambda`
Returns:
  Result of the CreateAlias operation returned by the service.

#### createEventSourceMapping

    public CreateEventSourceMappingResult createEventSourceMapping(CreateEventSourceMappingRequest request)

Description copied from interface: `AWSLambda`

Identifies a stream as an event source for a Lambda function. It can be either an Amazon Kinesis stream or an Amazon DynamoDB stream. AWS Lambda invokes the specified function when records are posted to the stream.

This association between a stream source and a Lambda function is called the event source mapping.

<important>

This event source mapping is relevant only in the AWS Lambda pull model, where AWS Lambda invokes the function. For more information, go to AWS Lambda: How it Works in the AWS Lambda Developer Guide.

</important>

You provide mapping information (for example, which stream to read from and which Lambda function to invoke) in the request body.

Each event source, such as an Amazon Kinesis or a DynamoDB stream, can be associated with multiple AWS Lambda function. A given Lambda function can be associated with multiple AWS event sources.

If you are using versioning, you can specify a specific function version or an alias via the function name parameter. For more information about versioning, see AWS Lambda Function Versioning and Aliases.

This operation requires permission for the `lambda:CreateEventSourceMapping` action.

Specified by:
  `createEventSourceMapping` in interface `AWSLambda`
Returns:
  Result of the CreateEventSourceMapping operation returned by the service.

#### createFunction

    public CreateFunctionResult createFunction(CreateFunctionRequest request)

Description copied from interface: `AWSLambda`

Creates a new Lambda function. The function metadata is created from the request parameters, and the code for the function is provided by a .zip file in the request body. If the function name already exists, the operation will fail. Note that the function name is case-sensitive.

If you are using versioning, you can also publish a version of the Lambda function you are creating using the `Publish` parameter. For more information about versioning, see AWS Lambda Function Versioning and Aliases.

This operation requires permission for the `lambda:CreateFunction` action.

Specified by:
  `createFunction` in interface `AWSLambda`
Returns:
  Result of the CreateFunction operation returned by the service.

#### deleteAlias

    public DeleteAliasResult deleteAlias(DeleteAliasRequest request)

Description copied from interface: `AWSLambda`

Deletes the specified Lambda function alias. For more information, see Introduction to AWS Lambda Aliases.

This requires permission for the lambda:DeleteAlias action.

Specified by:
  `deleteAlias` in interface `AWSLambda`
Returns:
  Result of the DeleteAlias operation returned by the service.

#### deleteEventSourceMapping

    public DeleteEventSourceMappingResult deleteEventSourceMapping(DeleteEventSourceMappingRequest request)

Description copied from interface: `AWSLambda`

Removes an event source mapping. This means AWS Lambda will no longer invoke the function for events in the associated source.

This operation requires permission for the `lambda:DeleteEventSourceMapping` action.

Specified by:
  `deleteEventSourceMapping` in interface `AWSLambda`
Returns:
  Result of the DeleteEventSourceMapping operation returned by the service.

#### deleteFunction

    public DeleteFunctionResult deleteFunction(DeleteFunctionRequest request)

Description copied from interface: `AWSLambda`

Deletes the specified Lambda function code and configuration.

If you are using the versioning feature and you don't specify a function version in your `DeleteFunction` request, AWS Lambda will delete the function, including all its versions, and any aliases pointing to the function versions. To delete a specific function version, you must provide the function version via the `Qualifier` parameter. For information about function versioning, see AWS Lambda Function Versioning and Aliases.

When you delete a function the associated resource policy is also deleted. You will need to delete the event source mappings explicitly.

This operation requires permission for the `lambda:DeleteFunction` action.

Specified by:
  `deleteFunction` in interface `AWSLambda`
Returns:
  Result of the DeleteFunction operation returned by the service.

#### getAccountSettings

    public GetAccountSettingsResult getAccountSettings(GetAccountSettingsRequest request)

Description copied from interface: `AWSLambda`

Returns a customer's account settings.

You can use this operation to retrieve Lambda limit information such as code size and concurrency limits. For more information on limits, see AWS Lambda Limits. You can also retrieve resource usage statistics such as code storage usage and function count.

Specified by:
  `getAccountSettings` in interface `AWSLambda`
Returns:
  Result of the GetAccountSettings operation returned by the service.

#### getAlias

    public GetAliasResult getAlias(GetAliasRequest request)

Description copied from interface: `AWSLambda`

Returns the specified alias information such as the alias ARN, description, and function version it is pointing to. For more information, see Introduction to AWS Lambda Aliases.

This requires permission for the `lambda:GetAlias` action.

Specified by:
  `getAlias` in interface `AWSLambda`
Returns:
  Result of the GetAlias operation returned by the service.

#### getEventSourceMapping

    public GetEventSourceMappingResult getEventSourceMapping(GetEventSourceMappingRequest request)

Description copied from interface: `AWSLambda`

Returns configuration information for the specified event source mapping (see CreateEventSourceMapping).

This operation requires permission for the `lambda:GetEventSourceMapping` action.

Specified by:
  `getEventSourceMapping` in interface `AWSLambda`
Returns:
  Result of the GetEventSourceMapping operation returned by the service.

#### getFunction

    public GetFunctionResult getFunction(GetFunctionRequest request)

Description copied from interface: `AWSLambda`

Returns the configuration information of the Lambda function and a presigned URL link to the .zip file you uploaded with CreateFunction so you can download the .zip file. Note that the URL is valid for up to 10 minutes. The configuration information is the same information you provided as parameters when uploading the function.

Using the optional `Qualifier` parameter, you can specify a specific function version for which you want this information. If you don't specify this parameter, the API uses unqualified function ARN which return information about the `$LATEST` version of the Lambda function. For more information, see AWS Lambda Function Versioning and Aliases.

This operation requires permission for the `lambda:GetFunction` action.

Specified by:
  `getFunction` in interface `AWSLambda`
Returns:
  Result of the GetFunction operation returned by the service.

#### getFunctionConfiguration

    public GetFunctionConfigurationResult getFunctionConfiguration(GetFunctionConfigurationRequest request)

Description copied from interface: `AWSLambda`

Returns the configuration information of the Lambda function. This the same information you provided as parameters when uploading the function by using CreateFunction.

If you are using the versioning feature, you can retrieve this information for a specific function version by using the optional `Qualifier` parameter and specifying the function version or alias that points to it. If you don't provide it, the API returns information about the $LATEST version of the function. For more information about versioning, see AWS Lambda Function Versioning and Aliases.

This operation requires permission for the `lambda:GetFunctionConfiguration` operation.

Specified by:
  `getFunctionConfiguration` in interface `AWSLambda`
Returns:
  Result of the GetFunctionConfiguration operation returned by the service.

#### getPolicy

    public GetPolicyResult getPolicy(GetPolicyRequest request)

Description copied from interface: `AWSLambda`

Returns the resource policy associated with the specified Lambda function.

If you are using the versioning feature, you can get the resource policy associated with the specific Lambda function version or alias by specifying the version or alias name using the `Qualifier` parameter. For more information about versioning, see AWS Lambda Function Versioning and Aliases.

For information about adding permissions, see AddPermission.

You need permission for the `lambda:GetPolicy action.`

Specified by:
  `getPolicy` in interface `AWSLambda`
Returns:
  Result of the GetPolicy operation returned by the service.

#### invoke

    public InvokeResult invoke(InvokeRequest request)

Description copied from interface: `AWSLambda`

Invokes a specific Lambda function. For an example, see Create the Lambda Function and Test It Manually.

If you are using the versioning feature, you can invoke the specific function version by providing function version or alias name that is pointing to the function version using the `Qualifier` parameter in the request. If you don't provide the `Qualifier` parameter, the `$LATEST` version of the Lambda function is invoked. Invocations occur at least once in response to an event and functions must be idempotent to handle this. For information about the versioning feature, see AWS Lambda Function Versioning and Aliases.

This operation requires permission for the `lambda:InvokeFunction` action.

Specified by:
  `invoke` in interface `AWSLambda`
Returns:
  Result of the Invoke operation returned by the service.

#### invokeAsync

    @Deprecated
    public InvokeAsyncResult invokeAsync(InvokeAsyncRequest request)

Deprecated.
Description copied from interface: `AWSLambda`
<important>

This API is deprecated. We recommend you use `Invoke` API (see Invoke).

</important>

Submits an invocation request to AWS Lambda. Upon receiving the request, Lambda executes the specified function asynchronously. To see the logs generated by the Lambda function execution, see the CloudWatch Logs console.

This operation requires permission for the `lambda:InvokeFunction` action.

Specified by:
  `invokeAsync` in interface `AWSLambda`
Returns:
  Result of the InvokeAsync operation returned by the service.

#### listAliases

    public ListAliasesResult listAliases(ListAliasesRequest request)

Description copied from interface: `AWSLambda`

Returns list of aliases created for a Lambda function. For each alias, the response includes information such as the alias ARN, description, alias name, and the function version to which it points. For more information, see Introduction to AWS Lambda Aliases.

This requires permission for the lambda:ListAliases action.

Specified by:
  `listAliases` in interface `AWSLambda`
Returns:
  Result of the ListAliases operation returned by the service.

#### listEventSourceMappings

    public ListEventSourceMappingsResult listEventSourceMappings(ListEventSourceMappingsRequest request)

Description copied from interface: `AWSLambda`

Returns a list of event source mappings you created using the `CreateEventSourceMapping` (see CreateEventSourceMapping).

For each mapping, the API returns configuration information. You can optionally specify filters to retrieve specific event source mappings.

If you are using the versioning feature, you can get list of event source mappings for a specific Lambda function version or an alias as described in the `FunctionName` parameter. For information about the versioning feature, see AWS Lambda Function Versioning and Aliases.

This operation requires permission for the `lambda:ListEventSourceMappings` action.

Specified by:
  `listEventSourceMappings` in interface `AWSLambda`
Returns:
  Result of the ListEventSourceMappings operation returned by the service.

#### listEventSourceMappings

    public ListEventSourceMappingsResult listEventSourceMappings()

Description copied from interface: `AWSLambda`
Simplified method form for invoking the ListEventSourceMappings operation.

Specified by:
  `listEventSourceMappings` in interface `AWSLambda`
See Also:
  `AWSLambda.listEventSourceMappings(ListEventSourceMappingsRequest)`

#### listFunctions

    public ListFunctionsResult listFunctions(ListFunctionsRequest request)

Description copied from interface: `AWSLambda`

Returns a list of your Lambda functions. For each function, the response includes the function configuration information. You must use GetFunction to retrieve the code for your function.

This operation requires permission for the `lambda:ListFunctions` action.

If you are using versioning feature, the response returns list of $LATEST versions of your functions. For information about the versioning feature, see AWS Lambda Function Versioning and Aliases.

Specified by:
  `listFunctions` in interface `AWSLambda`
Returns:
  Result of the ListFunctions operation returned by the service.

#### listFunctions

    public ListFunctionsResult listFunctions()

Description copied from interface: `AWSLambda`
Simplified method form for invoking the ListFunctions operation.

Specified by:
  `listFunctions` in interface `AWSLambda`
See Also:
  `AWSLambda.listFunctions(ListFunctionsRequest)`

#### listVersionsByFunction

    public ListVersionsByFunctionResult listVersionsByFunction(ListVersionsByFunctionRequest request)

Description copied from interface: `AWSLambda`

List all versions of a function. For information about the versioning feature, see AWS Lambda Function Versioning and Aliases.

Specified by:
  `listVersionsByFunction` in interface `AWSLambda`
Returns:
  Result of the ListVersionsByFunction operation returned by the service.

#### publishVersion

    public PublishVersionResult publishVersion(PublishVersionRequest request)

Description copied from interface: `AWSLambda`

Publishes a version of your function from the current snapshot of $LATEST. That is, AWS Lambda takes a snapshot of the function code and configuration information from $LATEST and publishes a new version. The code and configuration cannot be modified after publication. For information about the versioning feature, see AWS Lambda Function Versioning and Aliases.

Specified by:
  `publishVersion` in interface `AWSLambda`
Returns:
  Result of the PublishVersion operation returned by the service.

#### removePermission

    public RemovePermissionResult removePermission(RemovePermissionRequest request)

Description copied from interface: `AWSLambda`

You can remove individual permissions from an resource policy associated with a Lambda function by providing a statement ID that you provided when you added the permission.

If you are using versioning, the permissions you remove are specific to the Lambda function version or alias you specify in the `AddPermission` request via the `Qualifier` parameter. For more information about versioning, see AWS Lambda Function Versioning and Aliases.

Note that removal of a permission will cause an active event source to lose permission to the function.

You need permission for the `lambda:RemovePermission` action.

Specified by:
  `removePermission` in interface `AWSLambda`
Returns:
  Result of the RemovePermission operation returned by the service.

#### updateAlias

    public UpdateAliasResult updateAlias(UpdateAliasRequest request)

Description copied from interface: `AWSLambda`

Using this API you can update the function version to which the alias points and the alias description. For more information, see Introduction to AWS Lambda Aliases.

This requires permission for the lambda:UpdateAlias action.

Specified by:
  `updateAlias` in interface `AWSLambda`
Returns:
  Result of the UpdateAlias operation returned by the service.

#### updateEventSourceMapping

    public UpdateEventSourceMappingResult updateEventSourceMapping(UpdateEventSourceMappingRequest request)

Description copied from interface: `AWSLambda`

You can update an event source mapping. This is useful if you want to change the parameters of the existing mapping without losing your position in the stream. You can change which function will receive the stream records, but to change the stream itself, you must create a new mapping.

If you are using the versioning feature, you can update the event source mapping to map to a specific Lambda function version or alias as described in the `FunctionName` parameter. For information about the versioning feature, see AWS Lambda Function Versioning and Aliases.

If you disable the event source mapping, AWS Lambda stops polling. If you enable again, it will resume polling from the time it had stopped polling, so you don't lose processing of any records. However, if you delete event source mapping and create it again, it will reset.

This operation requires permission for the `lambda:UpdateEventSourceMapping` action.

Specified by:
  `updateEventSourceMapping` in interface `AWSLambda`
Returns:
  Result of the UpdateEventSourceMapping operation returned by the service.

#### updateFunctionCode

    public UpdateFunctionCodeResult updateFunctionCode(UpdateFunctionCodeRequest request)

Description copied from interface: `AWSLambda`

Updates the code for the specified Lambda function. This operation must only be used on an existing Lambda function and cannot be used to update the function configuration.

If you are using the versioning feature, note this API will always update the $LATEST version of your Lambda function. For information about the versioning feature, see AWS Lambda Function Versioning and Aliases.

This operation requires permission for the `lambda:UpdateFunctionCode` action.

Specified by:
  `updateFunctionCode` in interface `AWSLambda`
Returns:
  Result of the UpdateFunctionCode operation returned by the service.

#### updateFunctionConfiguration

    public UpdateFunctionConfigurationResult updateFunctionConfiguration(UpdateFunctionConfigurationRequest request)

Description copied from interface: `AWSLambda`

Updates the configuration parameters for the specified Lambda function by using the values provided in the request. You provide only the parameters you want to change. This operation must only be used on an existing Lambda function and cannot be used to update the function's code.

If you are using the versioning feature, note this API will always update the $LATEST version of your Lambda function. For information about the versioning feature, see AWS Lambda Function Versioning and Aliases.

This operation requires permission for the `lambda:UpdateFunctionConfiguration` action.

Specified by:
  `updateFunctionConfiguration` in interface `AWSLambda`
Returns:
  Result of the UpdateFunctionConfiguration operation returned by the service.

#### shutdown

    public void shutdown()

Description copied from interface: `AWSLambda`
Shuts down this client object, releasing any resources that might be held open. This is an optional method, and callers are not expected to call it, but can if they want to explicitly release any open resources. Once a client has been shutdown, it should not be used to make any more requests.

Specified by:
  `shutdown` in interface `AWSLambda`

#### getCachedResponseMetadata

    public ResponseMetadata getCachedResponseMetadata(AmazonWebServiceRequest request)

Description copied from interface: `AWSLambda`
Returns additional metadata for a previously executed successful request, typically used for debugging issues where a service isn't acting as expected. This data isn't considered part of the result data returned by an operation, so it's available through this separate, diagnostic interface.

Response metadata is only cached for a limited period of time, so if you need to access this extra diagnostic information for an executed request, you should use this method to retrieve it as soon as possible after executing a request.

Specified by:
  `getCachedResponseMetadata` in interface `AWSLambda`
Parameters:
  `request` - The originally executed request.
Returns:
  The response metadata for the specified request, or null if none is available.